using System;
using System.Data;
using System.Data.Common;

namespace OnlinePhotoShop
{
	/// <summary>
	/// Abstract class providing API's to access the customer data base.
	/// </summary>
	public abstract class CustomerDB
	{
		abstract public DbDataAdapter CreateDataAdapter(string selectCondition);

		/// <summary>
		/// Authenticates a customer.
		/// </summary>
		/// <param name="email">Customer's Email address.</param>
		/// <param name="password">Secret password used for authentication.</param>
		/// <returns>Returns true if the authentication was succesfull.</returns>
		public bool Login(string email, string password)
		{
			// find matching record
			// (e.g. WHERE Email = 'user@mail.com' AND Password = 'secret' )
			DbDataAdapter dataAdapter = this.CreateDataAdapter(" WHERE Email = '" + email + "' AND Password = '" + password + "'");

			// query customer DB
			DataTable customer = new DataTable();
			dataAdapter.Fill(customer);

			if (customer.Rows.Count == 1)
			{
				// query successful
				return true;
			}

			// email or password are incorrect
			return false;
		}

		/// <summary>
		/// Adds a new customer to the database.
		/// </summary>
		/// <param name="email">Customer's Email address.</param>
		/// <param name="password">Secret password used for authentication.</param>
		/// <returns>Returns true if the customer was added to the database.</returns>
		public bool NewUser(string email, string password)
		{
			// see if the email already exists
			DbDataAdapter dataAdapter = this.CreateDataAdapter(" WHERE Email = '" + email + "'");

			// query customer DB
			DataTable customer = new DataTable();
			dataAdapter.Fill(customer);

			if (customer.Rows.Count != 0)
			{
				// account already created
				return false;
			}

			// insert new user into data base
			string [] newCustomer = new string[2];
			newCustomer[0] = email;
			newCustomer[1] = password;
			customer.Rows.Add(newCustomer);

			// commit changes to database
			dataAdapter.Update(customer);

			return true;
		}
	}
}
