using System;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;

namespace OnlinePhotoShop
{
	/// <summary>
	/// Login page for checkout area.
	/// </summary>
	/// <requirement>F:customer_login</requirement>
	/// <requirement>R:checkout_payment_secure</requirement>
	public class Login : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.HyperLink HyperLink1;
		protected System.Web.UI.WebControls.TextBox Email;
		protected System.Web.UI.WebControls.TextBox Password;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RadioButton ReturningCustomerButton;
		protected System.Web.UI.WebControls.RadioButton NewCustomerButton;
		protected System.Web.UI.WebControls.Button LoginButton;
		protected System.Web.UI.WebControls.Label ErrorLabel;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.LoginButton.Click += new System.EventHandler(this.LoginButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LoginButton_Click(object sender, System.EventArgs e)
		{
			bool issueTicket = false;
			CustomerDB db = (CustomerDB) Application.Get("CustomerDB");

			if (ReturningCustomerButton.Checked)
			{
				// verify login credentials
				issueTicket = db.Login(Email.Text, Password.Text);
			}
			else
			{
				// new customer
				issueTicket = db.NewUser(Email.Text, Password.Text);
			}

			if (issueTicket)
			{
				// issue new authentication ticket
				FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
					1,
					Email.Text,
					System.DateTime.Now,
					System.DateTime.Now.AddMinutes(20),
					false,
					"Customer",
					FormsAuthentication.FormsCookiePath);

				// encrypt the ticket
				string encTicket = FormsAuthentication.Encrypt(ticket);

				// create the cookie
				Response.Cookies.Add(new HttpCookie(FormsAuthentication.FormsCookieName, encTicket));

				// redirect back to original URL
				Response.Redirect(FormsAuthentication.GetRedirectUrl(Email.Text, false));
			}
			else
			{
				ErrorLabel.Visible = true;
			}
		}
	}
}
